package eu.mhsl.minenet.minigames.command;

import eu.mhsl.minenet.minigames.command.admin.*;
import eu.mhsl.minenet.minigames.command.user.HubCommand;
import eu.mhsl.minenet.minigames.command.user.LeaveCommand;
import eu.mhsl.minenet.minigames.message.Icon;
import eu.mhsl.minenet.minigames.message.type.ChatMessage;
import net.minestom.server.MinecraftServer;
import net.minestom.server.command.builder.Command;

public enum Commands {
    HUB(new HubCommand()),
    LEAVE(new LeaveCommand()),

    DEBUG(new DebugCommand()),
    FLY(new FlyCommand()),
    GAMEMODE(new GamemodeCommand()),
    GC(new GcCommand()),
    LANGTEST(new LangTestCommand()),
    ROOM(new RoomCommand()),
    UPDATE(new UpdateCommand());

    Commands(Command handler) {
        MinecraftServer.getCommandManager().register(handler);
    }

    static {
        MinecraftServer.getCommandManager().setUnknownCommandCallback((sender, command) -> {
            if(command.isBlank()) return;
            new ChatMessage(Icon.ERROR).appendStatic("Unknown command").quote(command).send(sender);
        });
    }
}
