package eu.mhsl.minenet.minigames.handler.global;

import eu.mhsl.minenet.minigames.instance.room.Room;
import eu.mhsl.minenet.minigames.skin.SkinCache;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.Player;
import net.minestom.server.event.EventListener;
import net.minestom.server.event.player.PlayerLoginEvent;
import eu.mhsl.minenet.minigames.instance.hub.Hub;
import net.minestom.server.permission.Permission;
import net.minestom.server.timer.TaskSchedule;
import org.jetbrains.annotations.NotNull;

import java.util.logging.Logger;

public class PlayerLoginHandler implements EventListener<PlayerLoginEvent> {
    @Override
    public @NotNull Class<PlayerLoginEvent> eventType() {
        return PlayerLoginEvent.class;
    }

    @Override
    public @NotNull Result run(@NotNull PlayerLoginEvent event) {

        Player p = event.getPlayer();

        p.setRespawnPoint(Hub.INSTANCE.getSpawn());
        p.sendMessage(p.getUuid().toString());
        event.setSpawningInstance(Hub.INSTANCE);
        SkinCache.applySkin(p);

        MinecraftServer.getSchedulerManager().scheduleTask(() -> {
            Room minetecsRoom = Room.getRoom(MinecraftServer.getConnectionManager().getPlayer("minetec"));
            if(minetecsRoom != null) {
                Room.setRoom(event.getPlayer(), minetecsRoom);
            }
        }, TaskSchedule.seconds(1), TaskSchedule.stop());

        if(p.getUsername().equalsIgnoreCase("minetec"))
            p.addPermission(new Permission("admin"));

        Logger.getLogger("user").info(p.getUsername() + " joined");

        return Result.SUCCESS;
    }
}
