package eu.mhsl.minenet.minigames.instance.game.minigame.config;

import eu.mhsl.minenet.minigames.instance.game.minigame.Minigame;
import net.kyori.adventure.text.Component;
import net.minestom.server.instance.block.Block;
import net.minestom.server.item.Material;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface GameFactory {
    Component name();
    ConfigManager configuration();

    default Material symbol() {
        return Material.GRASS_BLOCK;
    };
    default Component description() {
        return Component.text("- Keine Beschreibung -");
    };

    Minigame manufacture(Map<String, Option<?>> configuration);
    default Minigame manufacture(List<Option<?>> configuration) {
        if(configuration == null) return manufacture();
        Map<String, Option<?>> cnf = new HashMap<>();
        configuration.forEach(option -> cnf.put(option.getId(), option));
        return manufacture(cnf);
    }
    default Minigame manufacture() {
        if(this.configuration() == null) return manufacture(List.of());
        return manufacture(this.configuration().getAll());
    }
}
