package eu.mhsl.minenet.minigames.instance.game.minigame.config;

import net.kyori.adventure.text.Component;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;

import java.util.List;

public abstract class Option<T> {
    private final Material item;
    private final String name;
    private final String id;

    protected T currentValue;
    private final List<T> options;
    private int pointer = 0;

    public Option(String id, Material item, String name, List<T> options) {
        this.id = id;
        this.item = item;
        this.name = name;
        this.options = options;

        currentValue = options.get(0);
    }

    public ItemStack getNext() {
        if(++pointer >= options.size()) pointer = 0;
        currentValue = options.get(pointer);
        return getCurrent();
    }

    public ItemStack getCurrent() {
        int amount = Integer.parseInt(options.get(pointer).toString());
        return ItemStack.builder(item)
                .displayName(Component.text(name).append(Component.text(" - ")).append(Component.text(amount)))
                .build();
    }

    public int getAsInt() {
        return Integer.parseInt(getAsString());
    }

    public String getAsString() {
        return currentValue.toString();
    }

    public String getId() {
        return id;
    }
}
