package eu.mhsl.minenet.minigames.instance.hub.inventory;

import eu.mhsl.minenet.minigames.instance.room.Room;
import eu.mhsl.minenet.minigames.shared.inventory.InteractableInventory;
import net.kyori.adventure.text.Component;
import net.minestom.server.inventory.InventoryType;
import net.minestom.server.item.ItemHideFlag;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;

public class HubInventory extends InteractableInventory {
    public HubInventory() {
        super(InventoryType.CHEST_3_ROW, Component.text("MineNet Servernetzwerk"));

        setClickableItem(
                ItemStack
                        .builder(Material.WRITABLE_BOOK)
                        .displayName(Component.text("Create own room"))
                        .lore(Component.text("Create new empty room"))
                        .meta(metaBuilder -> metaBuilder.hideFlag(ItemHideFlag.HIDE_ATTRIBUTES))
                        .build(),
                12,
                itemClick -> Room.createRoom(itemClick.getPlayer()),
                true
        );

        setClickableItem(
                ItemStack
                        .builder(Material.KNOWLEDGE_BOOK)
                        .displayName(Component.text("Browse room"))
                        .lore(Component.text("Browse existing rooms"))
                        .build(),
                14,
                itemClick -> itemClick.getPlayer().openInventory(new JoinInventory())
        );
    }
}
