package eu.mhsl.minenet.minigames.instance.room.inventory;

import eu.mhsl.minenet.minigames.instance.game.GameList;
import eu.mhsl.minenet.minigames.instance.game.GameType;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.GameConfigurationInventory;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.GameFactory;
import eu.mhsl.minenet.minigames.shared.inventory.InteractableInventory;
import net.kyori.adventure.text.Component;
import net.minestom.server.inventory.InventoryType;
import net.minestom.server.item.ItemHideFlag;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;

public class MinigameTypeSelectInventory extends InteractableInventory {
    public MinigameTypeSelectInventory() {
        super(InventoryType.CHEST_6_ROW, Component.text("MineNet Servernetzwerk"));

        int typeCount = 0;
        for (GameType type : GameType.values()) {
            setClickableItem(
                    ItemStack.builder(type.getIcon())
                            .displayName(type.getTitle().asComponent())
                            .lore(type.getDescription().asComponent())
                            .build(),
                    typeCount,
                    itemClick -> {
                        drawGames(type);
                    }
            );
            typeCount++;
        }

        for(int i = 9; i <= 17; i++) {
            setDummyItem(Material.CYAN_STAINED_GLASS_PANE, i);
        }


    }

    private void drawGames(GameType type) {
        for(int i = 18; i <= 53; i++) {
            setDummyItem(Material.AIR, i);
        }
        int gameCount = 18;
        for (GameList gameList : GameList.values()) {
            if(!gameList.getType().equals(type)) continue;

            GameFactory gameFactory = gameList.getFactory();

            setClickableItem(
                    ItemStack.builder(gameFactory.symbol())
                            .displayName(gameFactory.name())
                            .lore(gameFactory.description())
                            .meta(metaBuilder -> metaBuilder.hideFlag(ItemHideFlag.HIDE_ATTRIBUTES))
                            .build(),
                    gameCount,
                    itemClick -> itemClick.getPlayer().openInventory(new GameConfigurationInventory(gameFactory))
            );
            gameCount++;
        }
    }
}
