package eu.mhsl.minenet.minigames.message.component;

import eu.mhsl.minenet.minigames.lang.Languages;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.ComponentLike;
import net.minestom.server.entity.Player;
import org.jetbrains.annotations.NotNull;

public class TranslatedComponent implements ComponentLike, Translatable {
    private String mapId;
    private String result;

    public static TranslatedComponent raw(String mapId) {
        return new TranslatedComponent(mapId);
    }

    private TranslatedComponent(String mapId) {
        this.mapId = mapId;
    }

    public void assemble(Player p) {
        result = Languages.getInstance().getLanguage(p).getEntry(mapId);
    }

    public void assemble(String language) {
        result = Languages.getInstance().getLanguage(language).getEntry(mapId);
    }

    public Component getAssembled(Player p) {
        this.assemble(p);
        return asComponent();
    }

    @Override
    public @NotNull Component asComponent() {
        assemble(Languages.getInstance().getLanguage(Languages.defaultLanguage).getEntry(mapId));
        return Component.text(result);
    }
}
